﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Binding_to_Child_Data_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private DataSet ds;
        private void Form1_Load(object sender, EventArgs e)
        {
            ds = new DataSet();
            DataTable dt = ds.Tables.Add("Parent");
            DataColumn dc = dt.Columns.Add("Key", typeof(int));
            dc.AutoIncrement = true;
            dt.Columns.Add("Name", typeof(string));

            dt.Rows.Add(new object[] { null, "Apple" });
            dt.Rows.Add(new object[] { null, "Banana" });
            dt.Rows.Add(new object[] { null, "Cherry" });

            dt = ds.Tables.Add("Child");
            dc = dt.Columns.Add("Key", typeof(int));
            dc.AutoIncrement = true;
            dt.Columns.Add("ParentKey", typeof(int));
            dt.Columns.Add("Price", typeof(int));

            dt.Rows.Add(new object[] { null, 0, 1 });
            dt.Rows.Add(new object[] { null, 0, 2 });
            dt.Rows.Add(new object[] { null, 0, 3 });
            dt.Rows.Add(new object[] { null, 1, 4 });
            dt.Rows.Add(new object[] { null, 1, 5 });
            dt.Rows.Add(new object[] { null, 1, 6 });
            dt.Rows.Add(new object[] { null, 2, 7 });
            dt.Rows.Add(new object[] { null, 2, 8 });
            dt.Rows.Add(new object[] { null, 2, 9 });
            ds.AcceptChanges();

            ds.Relations.Add("Parent-Child", ds.Tables["Parent"].Columns["Key"], ds.Tables["Child"].Columns["ParentKey"]);

            //this.ultraGrid1.SetDataBinding(ds, "Parent");

            // Bind a Numeric Editor to the Price field in the child band. 
            //this.ultraNumericEditor1.DataBindings.Add("Value", ds, "Parent.Parent-Child.Price");

            // Bind the child grid to the entire child list. 
            //this.ultraGrid2.SetDataBinding(ds, "Parent.Parent-Child");

            this.bsParent.DataSource = this.ds;
            this.bsParent.DataMember = "Parent";
            this.ultraGrid1.DataSource = this.bsParent;

            this.bsChild.DataSource = this.bsParent;
            this.bsChild.DataMember = "Parent-Child";   // "Parent.Parent-Child" -> compile error
            this.ultraGrid2.DataSource = this.bsChild;

            this.ultraNumericEditor1.DataBindings.Add( "Value", this.bsChild, "Price" ); // "Parent.Parent-Child.Price" -> compile error
        }
    }
}
